<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: OpenSim::TableUtilities Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classOpenSim_1_1TableUtilities.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="classOpenSim_1_1TableUtilities-members.html">List of all members</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">OpenSim::TableUtilities Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a90448049b1bf93e347a773786ec4b581"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1TableUtilities.html#a90448049b1bf93e347a773786ec4b581">checkNonUniqueLabels</a> (std::vector&lt; std::string &gt; labels)</td></tr>
<tr class="memdesc:a90448049b1bf93e347a773786ec4b581"><td class="mdescLeft">&#160;</td><td class="mdescRight">Throws an exception if the same label appears more than once in the list of labels.  <a href="classOpenSim_1_1TableUtilities.html#a90448049b1bf93e347a773786ec4b581">More...</a><br /></td></tr>
<tr class="separator:a90448049b1bf93e347a773786ec4b581"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2bddb847372a70fef02da0f6e8b50504"><td class="memItemLeft" align="right" valign="top">static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1TableUtilities.html#a2bddb847372a70fef02da0f6e8b50504">isInDegrees</a> (const <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;table)</td></tr>
<tr class="memdesc:a2bddb847372a70fef02da0f6e8b50504"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns true if the table contains 'inDegrees' metadata set to 'yes', and returns false if the table contains 'inDegrees' metadata set to 'no'.  <a href="classOpenSim_1_1TableUtilities.html#a2bddb847372a70fef02da0f6e8b50504">More...</a><br /></td></tr>
<tr class="separator:a2bddb847372a70fef02da0f6e8b50504"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7d239e2f8fee1d9a7d5ecec02d056b0a"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1TableUtilities.html#a7d239e2f8fee1d9a7d5ecec02d056b0a">findStateLabelIndex</a> (const <a class="el" href="classOpenSim_1_1Array.html">Array</a>&lt; std::string &gt; &amp;labels, const std::string &amp;desired)</td></tr>
<tr class="memdesc:a7d239e2f8fee1d9a7d5ecec02d056b0a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the index in the provided array of labels that corresponds to the desired label.  <a href="classOpenSim_1_1TableUtilities.html#a7d239e2f8fee1d9a7d5ecec02d056b0a">More...</a><br /></td></tr>
<tr class="separator:a7d239e2f8fee1d9a7d5ecec02d056b0a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2831577f6e72f62b5d1400b00a4aa8ef"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1TableUtilities.html#a2831577f6e72f62b5d1400b00a4aa8ef">findStateLabelIndex</a> (const std::vector&lt; std::string &gt; &amp;labels, const std::string &amp;desired)</td></tr>
<tr class="memdesc:a2831577f6e72f62b5d1400b00a4aa8ef"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the index in the provided array of labels that corresponds to the desired label.  <a href="classOpenSim_1_1TableUtilities.html#a2831577f6e72f62b5d1400b00a4aa8ef">More...</a><br /></td></tr>
<tr class="separator:a2831577f6e72f62b5d1400b00a4aa8ef"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aed768eeb9c2d6111e7d5defcff766fc2"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1TableUtilities.html#aed768eeb9c2d6111e7d5defcff766fc2">filterLowpass</a> (<a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;table, double cutoffFreq, bool padData=false)</td></tr>
<tr class="memdesc:aed768eeb9c2d6111e7d5defcff766fc2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Lowpass filter the data in a TimeSeriesTable at a provided cutoff frequency.  <a href="classOpenSim_1_1TableUtilities.html#aed768eeb9c2d6111e7d5defcff766fc2">More...</a><br /></td></tr>
<tr class="separator:aed768eeb9c2d6111e7d5defcff766fc2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4c3536893b938c4cefca14f3a9bc2ec7"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1TableUtilities.html#a4c3536893b938c4cefca14f3a9bc2ec7">pad</a> (<a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;table, int numRowsToPrependAndAppend)</td></tr>
<tr class="memdesc:a4c3536893b938c4cefca14f3a9bc2ec7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Pad each column by the number of rows specified.  <a href="classOpenSim_1_1TableUtilities.html#a4c3536893b938c4cefca14f3a9bc2ec7">More...</a><br /></td></tr>
<tr class="separator:a4c3536893b938c4cefca14f3a9bc2ec7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a77a7796781eb7669f278f51dd0cac639"><td class="memTemplParams" colspan="2">template&lt;typename TimeVector , typename FunctionType  = GCVSpline&gt; </td></tr>
<tr class="memitem:a77a7796781eb7669f278f51dd0cac639"><td class="memTemplItemLeft" align="right" valign="top">static <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1TableUtilities.html#a77a7796781eb7669f278f51dd0cac639">resample</a> (const <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;in, const TimeVector &amp;newTime)</td></tr>
<tr class="memdesc:a77a7796781eb7669f278f51dd0cac639"><td class="mdescLeft">&#160;</td><td class="mdescRight">Resample (interpolate) the table at the provided times.  <a href="classOpenSim_1_1TableUtilities.html#a77a7796781eb7669f278f51dd0cac639">More...</a><br /></td></tr>
<tr class="separator:a77a7796781eb7669f278f51dd0cac639"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0f7642aa28e8b10ed1e565d0cadaf0a0"><td class="memTemplParams" colspan="2">template&lt;typename FunctionType  = GCVSpline&gt; </td></tr>
<tr class="memitem:a0f7642aa28e8b10ed1e565d0cadaf0a0"><td class="memTemplItemLeft" align="right" valign="top">static <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1TableUtilities.html#a0f7642aa28e8b10ed1e565d0cadaf0a0">resampleWithInterval</a> (const <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;in, double interval)</td></tr>
<tr class="memdesc:a0f7642aa28e8b10ed1e565d0cadaf0a0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Resample the table using the given time interval (using <a class="el" href="classOpenSim_1_1TableUtilities.html#a77a7796781eb7669f278f51dd0cac639" title="Resample (interpolate) the table at the provided times.">resample()</a>).  <a href="classOpenSim_1_1TableUtilities.html#a0f7642aa28e8b10ed1e565d0cadaf0a0">More...</a><br /></td></tr>
<tr class="separator:a0f7642aa28e8b10ed1e565d0cadaf0a0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:add0d66363fbba3bc8a9845904a09f1d6"><td class="memTemplParams" colspan="2">template&lt;typename FunctionType  = GCVSpline&gt; </td></tr>
<tr class="memitem:add0d66363fbba3bc8a9845904a09f1d6"><td class="memTemplItemLeft" align="right" valign="top">static <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1TableUtilities.html#add0d66363fbba3bc8a9845904a09f1d6">resampleWithIntervalBounded</a> (const <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;in, double interval)</td></tr>
<tr class="memdesc:add0d66363fbba3bc8a9845904a09f1d6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Same as <a class="el" href="classOpenSim_1_1TableUtilities.html#a0f7642aa28e8b10ed1e565d0cadaf0a0" title="Resample the table using the given time interval (using resample()).">resampleWithInterval()</a> but the interval may be reduced to ensure the number of sampling points does not exceed <a class="el" href="classOpenSim_1_1Storage.html#a01ca548239f18f19110f34443c76b6e0">Storage::MAX_RESAMPLE_SIZE</a>.  <a href="classOpenSim_1_1TableUtilities.html#add0d66363fbba3bc8a9845904a09f1d6">More...</a><br /></td></tr>
<tr class="separator:add0d66363fbba3bc8a9845904a09f1d6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aecdf93d58e48bc217af51b008e9512a2"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOpenSim_1_1TimeSeriesTable__.html">TimeSeriesTable_</a>&lt; SimTK::Vec3 &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1TableUtilities.html#aecdf93d58e48bc217af51b008e9512a2">convertRotationsToEulerAngles</a> (const <a class="el" href="classOpenSim_1_1TimeSeriesTable__.html">TimeSeriesTable_</a>&lt; SimTK::Rotation &gt; &amp;rotTable)</td></tr>
<tr class="separator:aecdf93d58e48bc217af51b008e9512a2"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a90448049b1bf93e347a773786ec4b581"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a90448049b1bf93e347a773786ec4b581">&#9670;&nbsp;</a></span>checkNonUniqueLabels()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::TableUtilities::checkNonUniqueLabels </td>
          <td>(</td>
          <td class="paramtype">std::vector&lt; std::string &gt;&#160;</td>
          <td class="paramname"><em>labels</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Throws an exception if the same label appears more than once in the list of labels. </p>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname"><a class="el" href="classOpenSim_1_1NonUniqueLabels.html">NonUniqueLabels</a></td><td></td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aecdf93d58e48bc217af51b008e9512a2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aecdf93d58e48bc217af51b008e9512a2">&#9670;&nbsp;</a></span>convertRotationsToEulerAngles()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOpenSim_1_1TimeSeriesTable__.html">TimeSeriesTable_</a>&lt;SimTK::Vec3&gt; OpenSim::TableUtilities::convertRotationsToEulerAngles </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1TimeSeriesTable__.html">TimeSeriesTable_</a>&lt; SimTK::Rotation &gt; &amp;&#160;</td>
          <td class="paramname"><em>rotTable</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="aed768eeb9c2d6111e7d5defcff766fc2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aed768eeb9c2d6111e7d5defcff766fc2">&#9670;&nbsp;</a></span>filterLowpass()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::TableUtilities::filterLowpass </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;&#160;</td>
          <td class="paramname"><em>table</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>cutoffFreq</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>padData</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Lowpass filter the data in a TimeSeriesTable at a provided cutoff frequency. </p>
<p>If padData is true, then the data is first padded with <a class="el" href="classOpenSim_1_1TableUtilities.html#a4c3536893b938c4cefca14f3a9bc2ec7" title="Pad each column by the number of rows specified.">pad()</a> using numRowsToPrependAndAppend = table.getNumRows() / 2. The filtering is performed with <a class="el" href="classOpenSim_1_1Signal.html#ab1d080b5dc69eb4830642407360e48f8">Signal::LowpassIIR()</a> </p>

</div>
</div>
<a id="a7d239e2f8fee1d9a7d5ecec02d056b0a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7d239e2f8fee1d9a7d5ecec02d056b0a">&#9670;&nbsp;</a></span>findStateLabelIndex() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int OpenSim::TableUtilities::findStateLabelIndex </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOpenSim_1_1Array.html">Array</a>&lt; std::string &gt; &amp;&#160;</td>
          <td class="paramname"><em>labels</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>desired</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the index in the provided array of labels that corresponds to the desired label. </p>
<p>This function attempts to handle the change in state variable names that occurred in <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> version 4.0; for example, if you search for <code>&lt;coord-name&gt;/speed</code> and it is not found, then this function looks for <code>&lt;coord-name&gt;_u</code>. If you search for <code>&lt;muscle&gt;/activation</code> and it is not found, then this function looks for <code>&lt;muscle&gt;.activation</code>. This function returns -1 if the desired label is not found. </p>

</div>
</div>
<a id="a2831577f6e72f62b5d1400b00a4aa8ef"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2831577f6e72f62b5d1400b00a4aa8ef">&#9670;&nbsp;</a></span>findStateLabelIndex() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int OpenSim::TableUtilities::findStateLabelIndex </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; std::string &gt; &amp;&#160;</td>
          <td class="paramname"><em>labels</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>desired</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the index in the provided array of labels that corresponds to the desired label. </p>
<p>This function attempts to handle the change in state variable names that occurred in <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> version 4.0; for example, if you search for <code>&lt;coord-name&gt;/speed</code> and it is not found, then this function looks for <code>&lt;coord-name&gt;_u</code>. If you search for <code>&lt;muscle&gt;/activation</code> and it is not found, then this function looks for <code>&lt;muscle&gt;.activation</code>. This function returns -1 if the desired label is not found. </p>

</div>
</div>
<a id="a2bddb847372a70fef02da0f6e8b50504"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2bddb847372a70fef02da0f6e8b50504">&#9670;&nbsp;</a></span>isInDegrees()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static bool OpenSim::TableUtilities::isInDegrees </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;&#160;</td>
          <td class="paramname"><em>table</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns true if the table contains 'inDegrees' metadata set to 'yes', and returns false if the table contains 'inDegrees' metadata set to 'no'. </p>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname"><a class="el" href="classOpenSim_1_1Exception.html" title="A class for basic exception functionality.">Exception</a></td><td>if table does not have 'inDegrees' table metadata. </td></tr>
    <tr><td class="paramname"><a class="el" href="classOpenSim_1_1Exception.html" title="A class for basic exception functionality.">Exception</a></td><td>if the 'inDegrees' metadata is neither 'yes' or 'no'. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a4c3536893b938c4cefca14f3a9bc2ec7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4c3536893b938c4cefca14f3a9bc2ec7">&#9670;&nbsp;</a></span>pad()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::TableUtilities::pad </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;&#160;</td>
          <td class="paramname"><em>table</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>numRowsToPrependAndAppend</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Pad each column by the number of rows specified. </p>
<p>The padded data is obtained by reflecting and negating the data in the table. Postcondition: the number of rows is table.getNumRows() + 2 * numRowsToPrependAndAppend. </p>

</div>
</div>
<a id="a77a7796781eb7669f278f51dd0cac639"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a77a7796781eb7669f278f51dd0cac639">&#9670;&nbsp;</a></span>resample()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename TimeVector , typename FunctionType  = GCVSpline&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> OpenSim::TableUtilities::resample </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const TimeVector &amp;&#160;</td>
          <td class="paramname"><em>newTime</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Resample (interpolate) the table at the provided times. </p>
<p>In general, a 5th-order <a class="el" href="classOpenSim_1_1GCVSpline.html" title="A class for representing a smooth function with a generalized cross-validation spline.">GCVSpline</a> is used as the interpolant; a lower order is used if the table has too few points for a 5th-order spline. Alternatively, you can provide a different function type as a template argument; currently, the only other supported function is <a class="el" href="classOpenSim_1_1PiecewiseLinearFunction.html" title="A class implementing a linear function.">PiecewiseLinearFunction</a>. </p><dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname"><a class="el" href="classOpenSim_1_1Exception.html" title="A class for basic exception functionality.">Exception</a></td><td>if new times are not within existing initial and final times, if the new times are decreasing, or if getNumTimes() &lt; 2. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a0f7642aa28e8b10ed1e565d0cadaf0a0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0f7642aa28e8b10ed1e565d0cadaf0a0">&#9670;&nbsp;</a></span>resampleWithInterval()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename FunctionType  = GCVSpline&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> OpenSim::TableUtilities::resampleWithInterval </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>interval</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Resample the table using the given time interval (using <a class="el" href="classOpenSim_1_1TableUtilities.html#a77a7796781eb7669f278f51dd0cac639" title="Resample (interpolate) the table at the provided times.">resample()</a>). </p>
<p>The new final time is not guaranteed to match the original final time. </p>

</div>
</div>
<a id="add0d66363fbba3bc8a9845904a09f1d6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#add0d66363fbba3bc8a9845904a09f1d6">&#9670;&nbsp;</a></span>resampleWithIntervalBounded()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename FunctionType  = GCVSpline&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> OpenSim::TableUtilities::resampleWithIntervalBounded </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> &amp;&#160;</td>
          <td class="paramname"><em>in</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>interval</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Same as <a class="el" href="classOpenSim_1_1TableUtilities.html#a0f7642aa28e8b10ed1e565d0cadaf0a0" title="Resample the table using the given time interval (using resample()).">resampleWithInterval()</a> but the interval may be reduced to ensure the number of sampling points does not exceed <a class="el" href="classOpenSim_1_1Storage.html#a01ca548239f18f19110f34443c76b6e0">Storage::MAX_RESAMPLE_SIZE</a>. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>OpenSim/Common/TableUtilities.h</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceOpenSim.html">OpenSim</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1TableUtilities.html">TableUtilities</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:51 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
